      SUBROUTINE TYPE
      LOGICAL ERR, SYSERR, ARDECL, ABORT, TOKLMO
      INTEGER STMT, PSTMT, DSA, PDSA
      COMMON /DETECT/ ERR, SYSERR, ABORT
      COMMON /FACTS/ NAME, NOST, ITYP, IASF
      COMMON /INPUT/ NSTMT, PSTMT, STMT(1327)
      COMMON /CTABL/ LDSA, PDSA, DSA(5000)
C
C     PROCESSES TYPE STMT BY FINDING IDS OR ARRAY DECLS
C     THEY ARE ENTERED INTO SYMBOL TABLE AND TYPED EXPLICITLY
C     NORMALLY, NO USAGE IS SET.  HOWEVER, LENGTH MODIFIERS ARE
C     TESTED FOR AND OBEYED WHEN POSSIBLE AFTER ISSUING 
C     APPROPRIATE ERROR MESSAGES, AND IN SUCH A CASE, THE TYPE
C     FLAGS MAY BE RESET.
C
   10 IF (.NOT.ARDECL(K2,INDX)) GO TO 20
      IF (SYSERR) GO TO 30
      L = IGATT1(INDX,6)
      IF(L.EQ.1) CALL ERROR1(63H WARNING - SHOULD TYPE ADJUSTABLE DIMENS
     1ION VARIABLE BEFORE USE, 63)
      IF (K2.EQ.NSTMT) GO TO 30
      IF (STMT(K2).EQ.68 .AND. K2+1.NE.NSTMT) GO TO 40
      INDXSV = INDX
      PSTMT = K2
      IF (.NOT.TOKLMO(PSTMT,K2,I1)) GO TO 20
C
C     TOKEN WAS A LENGTH MODIFIER.  ISSUE A WARNING MESSAGE, BUT
C     DO NOT SET ERROR FLAG, SINCE WE WILL JUST IGNORE THE
C     MODIFIER.
C
      PSTMT = K2
      CALL ERROR1 (
     X62H TYPE STATEMENT LENGTH MODIFIER IS ILLEGAL -- MODIFIER IGNORED,
     X62)
C
C     IF 'REAL*8' WAS SPECIFIED, ASSUME DOUBLE PRECISION AND ISSUE
C     A WARNING MESSAGE.
C
      IF (.NOT.( (ITYP .EQ. 2) .AND. (I1 .EQ. 8) )) GO TO 15
      CALL ERROR1 (
     1     52H LENGTH MODIFIER *8 ASSUMED TO MEAN DOUBLE PRECISION,52)
      CALL SATT1 (INDXSV, 1, 1+7)
C
C     GET THE NEXT TOKEN.  IF IT IS A COMMA OR END-OF-STATEMENT, 
C     WE HAVE SUCCESSFULLY MOVED PAST THE LENGTH MODIFIER.
C     OTHERWISE, JUST GIVE UP.
C
   15 CALL NEXTOK (PSTMT,K2,I1)
      K2 = K2 - 1
      IF (K2 .EQ. NSTMT) GO TO 30
      IF ((I1 .EQ. 3) .AND. (STMT(K2) .EQ. 68) .AND. 
     1     ((K2+1) .NE. NSTMT) ) GO TO 40
C
C     FOLLOWING TOKEN WAS NOT A LENGTH MODIFIER, SO FLAG AN ERROR.
C
   20 CALL ERROR1(15H ILLEGAL SYNTAX, 15)
   30 RETURN
   40 PSTMT = K2 + 1
      GO TO 10
      END
